package  
{
	import actors.IShootable;
	import flash.display.BitmapData;
	import flash.display.DisplayObject;
	import flash.display.MovieClip;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	/**
	 * ...
	 * @author christoffer@enedahl.com
	 */
	public class BaseObject implements IObject 
	{
		protected var _collisionRect:Rectangle;
		protected var _gfx:MovieClip;
		protected var _vel:Point;
		protected var _pos:Point;
		protected var _removeNextUpdate:Boolean = false;
		
		public function BaseObject( pGfx:MovieClip) 
		{
			_gfx = pGfx;
			_vel = new Point();
			_pos = new Point();
			
			_collisionRect = new Rectangle(0, 0, 32, 32);
		}
		
		public function get pos():Point 
		{
			return _pos;
		}
		
		public function update( pLastFrameTime:int ):void 
		{
			_pos.x += _vel.x;
			_pos.y += _vel.y;
		}
		
		public function render(dest:BitmapData, cameraPoint:Point):void 
		{
			_gfx.x = _pos.x - cameraPoint.x;
			_gfx.y = _pos.y - cameraPoint.y;
		}
		
		public function dispose():void 
		{
			if ( _gfx != null) {
				if ( _gfx.parent != null) {
					_gfx.parent.removeChild( _gfx);
				}
				_gfx = null;
			}
			
		}
		
		public function get removeNextUpdate():Boolean 
		{
			return _removeNextUpdate;
		}
		
		public function set removeNextUpdate(value:Boolean):void 
		{
			_removeNextUpdate = value;
		}
		
		public function get gfx():DisplayObject 
		{
			return _gfx;
		}
		
		public function get vel():Point 
		{
			return _vel;
		}
		
		public function get collisionRect():Rectangle 
		{
			return _collisionRect;
		}
		
	}

}