package  
{
	import flash.geom.Point;
	/**
	 * ...
	 * @author christoffer@enedahl.com
	 */
	public class Camera
	{
		public var x:Number = 0;
		public var y:Number = 0;
		public var velX:Number = 0;
		public var velY:Number = 0;
		//public var targetX:Number = 0;
		//public var targetY:Number = 0;
		
		public var spring:Number = 0.05;
		public var drag:Number = 0.8;
		
		private var _point:Point = new Point();
		private var _target:IObject;
		private var _centerX:int;
		private var _centerY:int;
		
		public function get point():Point
		{
			_point.x = int(x);
			_point.y = int(y);
			return _point;
		}
		
		public function Camera( viewWidth:int, viewHeight:int ) 
		{
			_centerY = viewHeight/2;
			_centerX = viewWidth/2;
			
		}
		
		public function setTarget( pTarget: IObject, pMoveThereInstantly:Boolean = false):void 
		{
			_target = pTarget;
			
			if ( pMoveThereInstantly ) {
				x += (_target.pos.x - _centerX) - x;
				y += (_target.pos.y - _centerY) - y;
			}
		}
		
		public function update():void 
		{
			
			if ( _target == null) {
				updateSpring();
				
			}else{
				
				var diffX:Number = (_target.pos.x - _centerX) - x;
				var diffY:Number = (_target.pos.y - _centerY) - y;
				
				if ( diffX < -20) {
					x += (diffX+20)
				}else if ( diffX > 20) {
					x += (diffX-20)
				}
				
				if ( diffY < -30) {
					y += (diffY+30)
				}else if ( diffY > 20) {
					y += (diffY-20)
				}
			}
			
		}
		
		public function updateSpring():void 
		{
			if ( _target != null) {
				
				var diffX:Number = (_target.pos.x - _centerX) - x;
				var diffY:Number = (_target.pos.y - _centerY) - y;
				
				diffX *= spring;
				diffY *= spring;
				
				velX += diffX;
				velY += diffY;
			}
			
			x += velX;
			y += velY;
			
			velX *= drag;
			velY *= drag;
			
		}
		
		public function dispose():void 
		{
			_target = null;
		}
		
	}

}