package  
{
	import actors.Player;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.BlendMode;
	import flash.display.Sprite;
	import flash.geom.ColorTransform;
	import flash.geom.Matrix;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.text.TextField;
	/**
	 * ...
	 * @author christoffer@enedahl.com
	 */
	public class Hud 
	{
		private var _gfx:Sprite;
		private var _heart:Bitmap;
		private var _hp:Bitmap;
		private var _dollars:Bitmap;
		private var _dollar:Bitmap;
		private var _dollarText:GameTextField;
		
		public function Hud() 
		{
			var gid:int = Main.map.getTilePropertyByName("heart").textureGidOriginal;
			_gfx = new Sprite();
			_heart = new Bitmap( Main.map.textures[gid].clone() );
			
			gid = Main.map.getTilePropertyByName("dollar").textureGidOriginal;
			_dollar = new Bitmap( Main.map.textures[gid].clone() );
			
			//if ( Main.player != null) {
				Main.player.changedHP.add( onChangedHP );
				Main.player.changedDollar.add( onChangedDollar );
				drawHearts( Main.player.hp, Main.player.maxHP );
				drawDollars( Main.player.dollar );
			//}
		}
		
		private function onChangedDollar( player:Player):void 
		{
			drawDollars( player.dollar );
		}
		
		public function dispose():void 
		{
			if ( _gfx != null) {
				if ( _gfx.parent != null) {
					_gfx.parent.removeChild( _gfx);
				}
				_gfx = null;
			}
			
			if ( _hp != null) {
				if ( _hp.parent != null) {
					_hp.parent.removeChild( _hp );
				}
				_hp = null;
			}
			
			try{
				Main.player.changedHP.remove( onChangedHP );
			}catch (err:Error) { }
			
			try{
				_heart.bitmapData.dispose();
				_dollar.bitmapData.dispose();
				
				_heart = null;
				_dollar = null;
			}catch (err:Error)
			{
				
			}
			
			if ( _dollarText != null) {
				_dollarText.dispose();
				_dollarText = null;
			}
		}
		
		private function onChangedHP( player:Player ):void 
		{
			drawHearts( player.hp, player.maxHP);
		}
		
		private function drawHearts(hp:int, maxHP:int):void 
		{
			if ( _hp != null) {
				_gfx.removeChild( _hp);
			}
			
			_hp = new Bitmap( new BitmapData(maxHP * 24, 32, true,0x00000000) );
			
			for (var i:int = 0; i < maxHP; i++) 
			{
				if ( hp >= (i+1)) {
					_hp.bitmapData.copyPixels( _heart.bitmapData, new Rectangle(0, 0, 32, 32), new Point(i * 24, 0));
				}else {
					var matrix:Matrix = new Matrix();
					matrix.translate(i * 24, 0);
					//
					_hp.bitmapData.draw( _heart, matrix, new ColorTransform (.5,.5,.5), BlendMode.NORMAL );
					
				}
			}
			
			_gfx.addChild(_hp);
		}
		
		private function drawDollars(dollars:int):void 
		{
			if ( _dollars == null) {
				_dollars = new Bitmap( new BitmapData(32, 32, true, 0x00000000) );
				_dollars.bitmapData.copyPixels( _dollar.bitmapData, new Rectangle(0, 0, 32, 32), new Point(0, 0));
				
				if( _hp != null){
					_dollars.x = _hp.width + 5;
				}else {
					_dollar.x = 100;
				}
				
				_dollarText = new GameTextField();
				_dollarText.setColor(0x000000);
				_dollarText.gfx.x = _dollars.x + _dollars.width ;
				_dollarText.gfx.y = 10 ;
				
				_gfx.addChild( _dollars );
				_gfx.addChild( _dollarText.gfx );
			}
			
			_dollarText.text = "$" + dollars.toString()
			
		}
		
		public function get gfx():Sprite 
		{
			return _gfx;
		}
		
		
	}

}