﻿package  
{
	import flash.display.DisplayObject;
	import flash.display.MovieClip;
	import flash.events.EventDispatcher;
	import flash.events.KeyboardEvent;
	import flash.events.MouseEvent;
	import flash.ui.Keyboard;
	import flash.utils.Dictionary;
	
	/**
	 * ...
	 * @author christoffer@enedahl.com
	 */
	public class Input extends EventDispatcher
	{
		public var mouseDown:Boolean = false;
		public var mouseEvent:MouseEvent = new MouseEvent( MouseEvent.MOUSE_MOVE);
		
		private var _map:Dictionary;
		
		// 90; //Z
		// 88; //X
		public static const UP:int 		= 38;
		public static const DOWN:int 	= 40;
		public static const LEFT:int 	= 37;
		public static const RIGHT:int 	= 39;
		public static const SPACE:int 	= 32; //Space
		public static const DELETE:int 	= 46; //Delete
		public static const RESET:int 	= 82; //R
		
		public static const Z:int 		= 90;//Z
		public static const X:int 		= 88;//X
		
		public static const UP2:int 	= 87;//W
		public static const DOWN2:int 	= 83;//S
		public static const LEFT2:int 	= 65;//A
		public static const RIGHT2:int 	= 68;//D

		public static const NUM1:int 	= 49;//1
		public static const NUM2:int 	= 50;//2
		public static const NUM3:int 	= 51;//3
		public static const NUM4:int 	= 52;//4
		
		public static const ESC:int 	= 27;//ESC
		public static const P:int 	    = 80;//P
		
		private var _currentFrame:int = 0;
		
		public function Input( sender:EventDispatcher ) 
		{	
			_map = new Dictionary( );
			_map[UP] = {isDown: false};
			_map[DOWN] = {isDown: false};
			_map[LEFT] = {isDown: false};
			_map[RIGHT] = {isDown: false};
			_map[UP2] = {isDown: false};
			_map[DOWN2] = {isDown: false};
			_map[LEFT2] = {isDown: false};
			_map[RIGHT2] = {isDown: false};
			//_map[Q] = {isDown: false};
			_map[NUM1] = {isDown: false};
			_map[NUM2] = {isDown: false};
			_map[NUM3] = {isDown: false};
			_map[NUM4] = {isDown: false};
			_map[SPACE] = {isDown: false};
			_map[DELETE] = {isDown: false};
			_map[RESET] = {isDown: false};
			_map[Z] = {isDown: false};
			_map[X] = {isDown: false};
			_map[P] = {isDown: false};
			_map[ESC] = {isDown: false};
			
			sender.addEventListener( KeyboardEvent.KEY_DOWN, onKeyDown, false, 0 , true);
			sender.addEventListener( KeyboardEvent.KEY_UP, onKeyUp, false, 0 , true);
			
			sender.addEventListener( MouseEvent.MOUSE_DOWN, onMouseDown);
			sender.addEventListener( MouseEvent.MOUSE_UP, onMouseUp);
			sender.addEventListener( MouseEvent.MOUSE_MOVE, onMouseMove);
		}
		
		public function nextFrame():void 
		{
			_currentFrame ++;
		}
		
		public function get mouseX():int 
		{
			return mouseEvent.stageX;// / mouseScale;
		}
		public function get mouseY():int 
		{
			return mouseEvent.stageY;// / mouseScale;
		}
		
		
		private function onMouseMove(e:MouseEvent):void 
		{
			mouseEvent = e;
			
			if (mouseDown != e.buttonDown) {
				mouseDown = e.buttonDown;
			}
		}
		
		private function onMouseUp(e:MouseEvent):void 
		{
			mouseEvent = e;
			mouseDown = false;
		}
		
		private function onMouseDown(e:MouseEvent):void 
		{
			mouseEvent = e;
			mouseDown = true;
		}
		
		public function getX():Number
		{
			var val:Number = ( _map[RIGHT].isDown)? 1:0;
			val -= ( _map[LEFT].isDown )? 1:0;
			return val;
		}
		
		public function getY():Number
		{
			var val:Number = ( _map[UP].isDown )? -1:0;
			val += ( _map[DOWN].isDown  )? 1:0;
			return val;
		}
		
		public function getX2():Number
		{
			var val:Number = ( _map[RIGHT2].isDown )? 1:0;
			val -= ( _map[LEFT2].isDown)? 1:0;
			return val;
		}
		
		public function getY2():Number
		{
			var val:Number = ( _map[UP2].isDown)? -1:0;
			val += ( _map[DOWN2].isDown )? 1:0;
			return val;
		}
		
		public function getKeyIsDown( key:int ):Boolean
		{
			return _map[key].isDown;
		}
		
		public function getKeyWasReleased( key:int ):Boolean
		{
			return _map[key].wasReleased == _currentFrame;
		}
		
		public function getKeyWasPressed( key:int ):Boolean
		{
			return _map[key].wasPressed == _currentFrame;
		}
		
		
		private function onKeyUp(e:KeyboardEvent):void 
		{
			var key:Object = _map[e.keyCode];
			if ( key != null) {
				key.isDown = false;
				key.wasReleased = _currentFrame;
			}
		}
		
		private function onKeyDown(e:KeyboardEvent):void 
		{
			var key:Object = _map[e.keyCode];
			if ( key == null) {
				trace( "unused key: "+ e.keyCode );
			}else {
				if( !key.isDown){
					key.isDown = true;
					key.wasPressed = _currentFrame;
				}
			}
		}
		
	}
	
}