package  
{
	import flash.geom.Point;
	import flash.utils.Dictionary;
	/**
	 * ...
	 * @author christoffer@enedahl.com
	 */
	public class ObjectDefinition 
	{
		private var _name:String;
		private var _type:String;
		private var _properties:Dictionary;
		private var _position:Point;
		private var _width:int;
		private var _height:int;
		
		/*
			<object name="start" type="spawn" x="648" y="399" width="46" height="32">
			   <properties>
				<property name="interval" value="2000"/><!-- arbitary properties -->
			   </properties>
			  </object>
		*/
  
		public function ObjectDefinition( objectNode:XML ) 
		{
			var ix:int = parseInt( objectNode.@x );
			var iy:int = parseInt( objectNode.@y );
			
			_position = new Point(ix, iy);
			_width = parseInt( objectNode.@width ) ;
			_height = parseInt( objectNode.@height ) ;
			
			_name = objectNode.@name;
			_type = objectNode.@type;
			
			_properties = new Dictionary();
			
			for each(var prop:XML in objectNode.properties.property) {
				var propName:String = prop.@name;
				var value:String = prop.@value;
				
				_properties[propName] = value;
			}
		}
		
		public function get x():int 
		{
			return _position.x;
		}
		
		public function get y():int 
		{
			return _position.y;
		}
		
		public function get name():String 
		{
			return _name;
		}
		
		public function get type():String 
		{
			return _type;
		}
		
		public function get properties():Dictionary 
		{
			return _properties;
		}
		
		public function get position():Point 
		{
			return _position;
		}
		
	}

}