package  
{
	import flash.geom.Point;
	/**
	 * ...
	 * @author christoffer@enedahl.com
	 */
	public class TileProperty
	{
		public var show_as:String;
		
		private var _type:TilePropertyType;
		private var _value:Number;
		private var _textureGid:int = 0;
		private var _textureGidOriginal:int = 0;
		private var _spawn:String;
		
		public function TileProperty( pOptionalType:TilePropertyType = null, pTextureGid:Number = 0, pValue:Number = NaN, pSpawn:String = null ) 
		{
			_spawn = pSpawn;
			_type = pOptionalType;
			_textureGid = pTextureGid;
			_textureGidOriginal = _textureGid;
			_value = pValue;
		}
		
		public function get isWall():Boolean 
		{
			switch (type) {
				case TilePropertyType.WALL:
				case TilePropertyType.UNDEFINED:
				
				return true;
			}
			
			return false;
		}
		
		public function get isStatic():Boolean
		{
			return type == TilePropertyType.UNDEFINED;
		}
		
		public function get type():TilePropertyType { return _type; }
		
		public function get value():Number { return _value; }
		
		public function get textureGid():int { return _textureGid; }
		
		public function set textureGid(value:int):void 
		{
			_textureGid = value;
		}
		
		public function get textureGidOriginal():int 
		{
			return _textureGidOriginal;
		}
		
		public function get spawn():String 
		{
			return _spawn;
		}
		
		public function toString():String
		{
			return type.toString() +" tex: " + textureGid +" value "+ value;
		}
		
	}

}