package 
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Loader;
	import flash.display.LoaderInfo;
	import flash.events.Event;
	import flash.net.URLRequest;
	import org.osflash.signals.Signal;
	/**
	 * ...
	 * @author christoffer@enedahl.com
	 */
	public class TileSet
	{
		public var firstGid:int = 1;
		public var tilewidth:int = 1;
		public var tileheight:int = 1;
		public var bitmapData:BitmapData;
		public var name:String;
		
		public var loaded:Signal = new Signal(TileSet);
		public var isLoaded:Boolean = false;
		
		public function TileSet( pXml:XML, pFolder:String ) 
		{
			/*
			<tileset firstgid="1" name="TheTiles" tilewidth="16" tileheight="16">
				<image source="assets/tiles01.png" trans ="000000"/>
			</tileset>
			*/
			
			firstGid = parseInt( pXml.@firstgid );
			tilewidth = parseInt( pXml.@tilewidth );
			tileheight = parseInt( pXml.@tileheight );
			name = pXml.@name;
			
			for each( var image:XML in pXml.image ){
			
				var loader:Loader = new Loader();
				loader.contentLoaderInfo.addEventListener(Event.COMPLETE, onBitmapDataLoaded );
				loader.load( new URLRequest( pFolder + image.@source ) );
			
			}
		}
		
		private function onBitmapDataLoaded(e:Event):void 
		{
			var loader:LoaderInfo = LoaderInfo(e.target);
			loader.removeEventListener(Event.COMPLETE, onBitmapDataLoaded );
			
			bitmapData = Bitmap(loader.content).bitmapData;
			
			isLoaded = true;
			loaded.dispatch( this );
		}
		
	}

}