package behaviours 
{
	import flash.geom.Point;
	import flash.geom.Rectangle;
	/**
	 * ...
	 * @author christoffer@enedahl.com
	 */
	public class BehaviourTriggerSensors implements IBehaviour
	{
		
		private var _main:Main;
		
		public function BehaviourTriggerSensors( pMain:Main ) {
			_main = pMain;
		}
		
		public function update(pObject:IObject, ix:int, iy:int):void
		{
			var tile:Tile = _main._currentLevel.getTile(ix, iy);
			
			if ( tile == null) return;
			if ( tile.tileProperty == null) return;
			
			if ( tile.tileProperty.type == TilePropertyType.BUTTON) {
			
				if ( tile.tileProperty.value == 0) {
					//Turn this button on!
					
					var pressedProp:TileProperty = _main._currentLevel.getTilePropertyByName("button_pressed")
					tile.tileProperty = pressedProp;
					
					var conn:TileConnection = _main._currentLevel.getConnectionAt(ix, iy);
					
					for each (var targetLoc:Point in conn.targets) 
					{
						var targetTile:Tile = _main._currentLevel.getTile(targetLoc.x, targetLoc.y);
						
						if ( targetTile == null ) continue;
						if ( targetTile.tileProperty == null ) continue;
						
						if ( targetTile.tileProperty.type == TilePropertyType.HATCH ) {
							
							if ( targetTile.tileProperty.value == 0) {
								targetTile.tileProperty = _main._currentLevel.getTilePropertyByName("hatch_open");
							}else{
								targetTile.tileProperty = _main._currentLevel.getTilePropertyByName("hatch");
							}
							
						}else if ( targetTile.tileProperty.type == TilePropertyType.WATER_SOURCE ) {
							
							if ( targetTile.tileProperty.value == 0) {
								targetTile.tileProperty = _main._currentLevel.getTilePropertyByName("water_source_on");
							}else {
								targetTile.tileProperty = _main._currentLevel.getTilePropertyByName("water_source_off");
							}
							
						}
					}
				
				}
				
			}
		}
		
		public function dispose():void
		{
			_main = null;
		}
		
	}

}