package utils 
{
	import flash.display.DisplayObject;
	import flash.display.Loader;
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.media.Sound;
	import flash.net.URLRequest;
	import flash.utils.getDefinitionByName;
	import org.osflash.signals.Signal;
	/**
	 * ...
	 * @author christoffer@enedahl.com
	 */
	public class Assets 
	{
		private var _complete:Signal = new Signal(Boolean);
		private var _data:DisplayObject;
		
		public function Assets() 
		{
			
		}
		
		public function load( pUrl:URLRequest ):void 
		{
			var loader:ContentLoader = new ContentLoader();
			loader.complete.addOnce( onCompleted );
			loader.load( pUrl );
		}
		
		private function onCompleted(pSuccess:Boolean, pData:DisplayObject ):void 
		{
			if( pSuccess ){
				_data = pData;
			}
			_complete.dispatch(pSuccess);
		}
		
		public function newMovieClip( pSymbolName:String ):MovieClip
		{
			var factoryClass:Class = Class( _data.loaderInfo.applicationDomain.getDefinition( pSymbolName ) );
			if ( factoryClass == null) {
				return new MovieClip();
			}
			return new factoryClass() as MovieClip;
		}
		
		public function newSound( pSymbolName:String ):Sound
		{
			var factoryClass:Class = Class( _data.loaderInfo.applicationDomain.getDefinition( pSymbolName ) );
			if ( factoryClass == null) {
				return new Sound();
			}
			return new factoryClass() as Sound;
		}
		
		public function dispose():void 
		{
			if ( _complete!= null) {
				_complete.removeAll();
				_complete = null
			}
			_data = null;
		}
		
		public function newSprite(pSymbolName:String):Sprite 
		{
			var factoryClass:Class = Class( _data.loaderInfo.applicationDomain.getDefinition( pSymbolName ) );
			if ( factoryClass == null) {
				return new Sprite();
			}
			return new factoryClass() as Sprite;
		}
		
		public function get complete():Signal 
		{
			return _complete;
		}
	}

}