package utils 
{
	import flash.display.DisplayObject;
	import flash.display.Loader;
	import flash.display.LoaderInfo;
	import flash.errors.IOError;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import org.osflash.signals.Signal;
	/**
	 * ...
	 * @author christoffer@enedahl.com
	 */
	public class ContentLoader 
	{
		private var _loader:Loader;
		private var _complete:Signal = new Signal(Boolean , DisplayObject);
		
		public function ContentLoader(){}
		
		public function load( pUrl:URLRequest ):void 
		{
			trace("Load " + pUrl.url);
			
			var _loader:Loader = new Loader();
			_loader.contentLoaderInfo.addEventListener(Event.COMPLETE, onDataLoaded );
			_loader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR , onDataFailed );
			
			try{
				_loader.load( pUrl );
			}catch (err:SecurityError)
			{
				_complete.dispatch(false, null);
			}
			
		}
		
		private function onDataFailed(e:IOErrorEvent):void 
		{
			_complete.dispatch( false, null);
			dispose();
		}
		
		private function onDataLoaded(e:Event):void 
		{
			var loader:LoaderInfo = LoaderInfo(e.target);
			var payLoad:DisplayObject = loader.content
			
			_complete.dispatch( true, payLoad);
			
			dispose();
		}
		
		private function dispose():void 
		{
		
			if ( _loader!= null) {
				_loader.contentLoaderInfo.removeEventListener(Event.COMPLETE, onDataLoaded );
				_loader.contentLoaderInfo.removeEventListener(IOErrorEvent.IO_ERROR , onDataFailed );
				_loader = null
			}
		
			
			if ( _complete != null) {
				_complete.removeAll();
				_complete = null
			}
		}
		
		public function get complete():Signal 
		{
			return _complete;
		}
		
	}

}