package utils 
{
	import flash.utils.getDefinitionByName;
	/**
	 * ...
	 * @author christoffer@enedahl.com
	 */
	public class Factory 
	{
		
		public function Factory() 
		{
			
		}
		
		public function spawn( object:ObjectDefinition ):ISpawnable 
		{
			var className:String = object.properties["class"] as String;
			if ( className == null) {
				trace("unable to spawn " + object.name +" no class defined");
				return null;
			}
			
			try{
				var objectClass:Class = getDefinitionByName(className) as Class;
				if ( objectClass == null) {
					trace("unable to spawn " + object.name +" no class found: '" + className +"'");
					return null;
				}
			
				var spawnedObject:ISpawnable = new objectClass() as ISpawnable;
				if ( spawnedObject == null) {
					trace("unable to spawn " + object.name +" class not ISpawnable");
					return null;
				}
				
				spawnedObject.setDefinition(object);
				
				return spawnedObject;
			
			}catch (err:Error)
			{
				trace("unable to spawn " + object.name +" class:"+ className +" "+ err );
			}
			return null;
		}
		
		public function spawnByName(className:String, x:int, y:int):IObject 
		{
			if ( className == null) {
				trace("unable to spawn no class defined");
				return null;
			}
			
			try{
				var objectClass:Class = getDefinitionByName(className) as Class;
				if ( objectClass == null) {
					trace("unable to spawn no class found: '" + className +"'");
					return null;
				}
			
				var spawnedObject:ISpawnable = new objectClass() as ISpawnable;
				if ( spawnedObject == null) {
					trace("unable to spawn " + className +" class not ISpawnable");
					return null;
				}
				
				var object:IObject = spawnedObject as IObject;
				object.pos.x = x;
				object.pos.y = y;
				return object;
			
			}catch (err:Error)
			{
				trace("unable to spawn class:"+ className +" "+ err );
			}
			return null;
		}
		
		
		
	}

}