package utils 
{
	import flash.display.Loader;
	import flash.errors.IOError;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import org.osflash.signals.Signal;
	/**
	 * ...
	 * @author christoffer@enedahl.com
	 */
	public class XMLLoader 
	{
		private var _loader:URLLoader;
		private var _complete:Signal = new Signal(Boolean , XML);
		
		public function XMLLoader() 
		{
			
		}
		
		public function load( pUrl:URLRequest ):void 
		{
			trace("Load " + pUrl.url);
			
			_loader = new URLLoader();
			_loader.addEventListener(Event.COMPLETE, onDataLoaded );
			_loader.addEventListener(IOErrorEvent.IO_ERROR , onDataFailed );
			
			try{
				_loader.load( pUrl );
			}catch (err:SecurityError)
			{
				_complete.dispatch(false, null);
			}
			
		}
		
		private function onDataFailed(e:IOErrorEvent):void 
		{
			_complete.dispatch( false, null);
			dispose();
		}
		
		private function onDataLoaded(e:Event):void 
		{
			var loader:URLLoader = URLLoader(e.target);
			var payLoad:XML = XML(loader.data);
			
			_complete.dispatch( true, payLoad);
			
			dispose();
		}
		
		public function dispose():void 
		{
		
			if ( _loader!= null) {
				_loader.removeEventListener(Event.COMPLETE, onDataLoaded );
				_loader.removeEventListener(IOErrorEvent.IO_ERROR , onDataFailed );
				_loader = null
			}
		
			
			if ( _complete != null) {
				_complete.removeAll();
				_complete = null
			}
		}
		
		public function get complete():Signal 
		{
			return _complete;
		}
		
	}

}