package weapons 
{
	import actors.IShootable;
	import flash.display.BitmapData;
	import flash.display.DisplayObject;
	import flash.display.MovieClip;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	/**
	 * ...
	 * @author christoffer@enedahl.com
	 */
	public class Bullet extends BaseObject
	{
		private var _owner:IObject;
		private var _timeOfRemoval:int;
		private var _damage:int = 1;
		
		public function Bullet( pGfx:MovieClip, pOwner:IObject, pTimeToLive:int = 500 ) 
		{
			super( pGfx );
			_owner = pOwner;
			_gfx = pGfx;
			
			_timeOfRemoval = Main.gameTime + pTimeToLive;
			
			_collisionRect = new Rectangle(0, 0, 32, 4);
		}
		
		override public function update( pLastFrameTime:int ):void 
		{
			_pos.x += _vel.x;
			_pos.y += _vel.y;
			
			if( _vel.x < 0 ){
				_gfx.scaleX = -1;
			}
			
			for each( var object:IObject in Main.world.objects) { //TODO optimize!
			
				if ( object != _owner) {
					if ( object is IShootable) {
						var shootThis:IShootable = object as IShootable;
						if ( shootThis.hitRect.containsPoint( _pos.subtract( object.pos )) ) {
							if ( !shootThis.isDead ) {
								
								shootThis.hit( this );
								_removeNextUpdate = true;
								return;
							}
						}
						
					}
				}
			}
			
			if ( _timeOfRemoval < Main.gameTime) {
				_removeNextUpdate = true;
			}
		}
		
		override public function dispose():void 
		{
			
			_owner = null;
			
			super.dispose();
		}
		
		public function get damage():int
		{
			return _damage;
		}
		
		
	}

}